int verzoegerung;
int[] regelWerk ;  //Startregelwerk
int[] zellen;
int breite,hoehe;
int q; //Seitenlänge gezeichnetes Quadrat
int generation = 0;//aktuelle zu zeichnende Generation


void setup() {
  breite = 1000;
  hoehe  = 600;
  surface.setSize(breite,hoehe);  
  background(255);
  //frameRate(10);//Um genauer beobachten zu können...
  regelWerk = new int[8];
  zufallRegelwerk();
  println(regelWerk);
  q = 3;
  zellen = new int[breite/q];
  neuStart();
}

void draw(){
 for (int i = 0; i < zellen.length; i++) {
   if (zellen[i] == 1) {fill(0);}
      else  { fill(255);}
      noStroke();
      rect(i*q, generation*q, q, q);
  }
  zellenErzeugen();
  naechsteGenerationErzeugen();
  if (generation == hoehe/q-5)noLoop();
}

void zellenErzeugen(){
   int[] naechsteGeneration = new int[zellen.length];
   for (int i = 1; i < zellen.length-1; i++) {
      int linkeZ   = zellen[i-1];   // Zustand linker Nachbar
      int mittlereZ = zellen[i];    // Zustand selbst
      int rechteZ   = zellen[i+1];  // Zustand rechter Nachbar
      naechsteGeneration[i] = regeln(linkeZ, mittlereZ, rechteZ); // nächste Generation mit Regelwerk erstellen
    }
}

int regeln (int links, int mitte, int rechts) {
    int regelNummer = 4*links+2*mitte+rechts;   
    return regelWerk[regelNummer] ;
  }
 
void naechsteGenerationErzeugen(){
  int[] naechsteGeneration = new int[zellen.length];//leeren Int-Array erzeugen
   // Mit Regelwerk nächste Generation berechnen
   // Ränder werden nicht beachtet
   for (int i = 1; i < zellen.length-1; i++) {
      int links = zellen[i-1];   
      int mitte = zellen[i];       
      int rechts = zellen[i+1];  
      naechsteGeneration[i] = regeln(links, mitte,rechts); 
   }
   zellen = naechsteGeneration;
   generation++;
}

void neuStart(){
  for (int i = 0; i < zellen.length; i++) {
      zellen[i] = 0;
    }
  zellen[zellen.length/2] = 1;    // Mittlere Zelle der 0.ten Generation bekommt eine 1
  generation = 0;
}

void mousePressed() {
  background(255);
  zufallRegelwerk();
  neuStart();
  loop();
}

void zufallRegelwerk(){
  for (int i = 0; i < 8; i++) {
      regelWerk[i] = int(random(2));
  }
  println(regelWerk);println(); //Zur Information
}